unit D3DKmtSub;

{$IMPORTEDDATA OFF}
{$MINENUMSIZE 4}

interface

uses Windows, WinAdd;

type
  D3DKMT_HANDLE = ULONG;

  LUID = record
    LowPart: ULONG;
    HighPart: Longint;
  end;

  KMTQUERYADAPTERINFOTYPE = (
    KMTQAITYPE_ADAPTERPERFDATA = 62
  );

  D3DKMT_CLOSEADAPTER = record
    hAdapter: D3DKMT_HANDLE;
  end;

  D3DKMT_OPENADAPTERFROMDEVICENAME = record
    pDeviceName: PCWSTR;
    hAdapter: D3DKMT_HANDLE;
    AdapterLuid: LUID;
  end;

  D3DKMT_QUERYADAPTERINFO = record
    hAdapter: D3DKMT_HANDLE;
    Type_: KMTQUERYADAPTERINFOTYPE;
    pPrivateDriverData: Pointer;
    PrivateDriverDataSize: UINT;
  end;

  D3DKMT_ADAPTER_PERFDATA = record
    PhysicalAdapterIndex: UINT32;
    MemoryFrequency: ULONGLONG;
    MaxMemoryFrequency: ULONGLONG;
    MaxMemoryFrequencyOC: ULONGLONG;
    MemoryBandwidth: ULONGLONG;
    PCIEBandwidth: ULONGLONG;
    FanRPM: ULONG;
    Power: ULONG;
    Temperature: ULONG;
    PowerStateOverride: ULONG;
  end;

  D3DKMT_QUERYSTATSTICS_REFERENCE_DMA_BUFFER = record
    NbCall: ULONG;
    NbAllocationsReferenced: ULONG;
    MaxNbAllocationsReferenced: ULONG;
    NbNULLReference: ULONG;
    NbWriteReference: ULONG;
    NbRenamedAllocationsReferenced: ULONG;
    NbIterationSearchingRenamedAllocation: ULONG;
    NbLockedAllocationReferenced: ULONG;
    NbAllocationWithValidPrepatchingInfoReferenced: ULONG;
    NbAllocationWithInvalidPrepatchingInfoReferenced: ULONG;
    NbDMABufferSuccessfullyPrePatched: ULONG;
    NbPrimariesReferencesOverflow: ULONG;
    NbAllocationWithNonPreferredResources: ULONG;
    NbAllocationInsertedInMigrationTable: ULONG;
  end;

  D3DKMT_QUERYSTATSTICS_RENAMING = record
    NbAllocationsRenamed: ULONG;
    NbAllocationsShrinked: ULONG;
    NbRenamedBuffer: ULONG;
    MaxRenamingListLength: ULONG;
    NbFailuresDueToRenamingLimit: ULONG;
    NbFailuresDueToCreateAllocation: ULONG;
    NbFailuresDueToOpenAllocation: ULONG;
    NbFailuresDueToLowResource: ULONG;
    NbFailuresDueToNonRetiredLimit: ULONG;
  end;

  D3DKMT_QUERYSTATISTICS_COUNTER = record
    Count: ULONG;
    Bytes: ULONGLONG;
  end;

  D3DKMT_QUERYSTATSTICS_PREPRATION = record
    BroadcastStall: ULONG;
    NbDMAPrepared: ULONG;
    NbDMAPreparedLongPath: ULONG;
    ImmediateHighestPreparationPass: ULONG;
    AllocationsTrimmed: D3DKMT_QUERYSTATISTICS_COUNTER;
  end;

  D3DKMT_QUERYSTATSTICS_PAGING_FAULT = record
    Faults: D3DKMT_QUERYSTATISTICS_COUNTER;
    FaultsFirstTimeAccess: D3DKMT_QUERYSTATISTICS_COUNTER;
    FaultsReclaimed: D3DKMT_QUERYSTATISTICS_COUNTER;
    FaultsMigration: D3DKMT_QUERYSTATISTICS_COUNTER;
    FaultsIncorrectResource: D3DKMT_QUERYSTATISTICS_COUNTER;
    FaultsLostContent: D3DKMT_QUERYSTATISTICS_COUNTER;
    FaultsEvicted: D3DKMT_QUERYSTATISTICS_COUNTER;
    AllocationsMEM_RESET: D3DKMT_QUERYSTATISTICS_COUNTER;
    AllocationsUnresetSuccess: D3DKMT_QUERYSTATISTICS_COUNTER;
    AllocationsUnresetFail: D3DKMT_QUERYSTATISTICS_COUNTER;
    AllocationsUnresetSuccessRead: ULONG;
    AllocationsUnresetFailRead: ULONG;
    Evictions: D3DKMT_QUERYSTATISTICS_COUNTER;
    EvictionsDueToPreparation: D3DKMT_QUERYSTATISTICS_COUNTER;
    EvictionsDueToLock: D3DKMT_QUERYSTATISTICS_COUNTER;
    EvictionsDueToClose: D3DKMT_QUERYSTATISTICS_COUNTER;
    EvictionsDueToPurge: D3DKMT_QUERYSTATISTICS_COUNTER;
    EvictionsDueToSuspendCPUAccess: D3DKMT_QUERYSTATISTICS_COUNTER;
  end;

  D3DKMT_QUERYSTATSTICS_PAGING_TRANSFER = record
    BytesFilled: ULONGLONG;
    BytesDiscarded: ULONGLONG;
    BytesMappedIntoAperture: ULONGLONG;
    BytesUnmappedFromAperture: ULONGLONG;
    BytesTransferredFromMdlToMemory: ULONGLONG;
    BytesTransferredFromMemoryToMdl: ULONGLONG;
    BytesTransferredFromApertureToMemory: ULONGLONG;
    BytesTransferredFromMemoryToAperture: ULONGLONG;
  end;

  D3DKMT_QUERYSTATSTICS_SWIZZLING_RANGE = record
    NbRangesAcquired: ULONG;
    NbRangesReleased: ULONG;
  end;

  D3DKMT_QUERYSTATSTICS_LOCKS = record
    NbLocks: ULONG;
    NbLocksWaitFlag: ULONG;
    NbLocksDiscardFlag: ULONG;
    NbLocksNoOverwrite: ULONG;
    NbLocksNoReadSync: ULONG;
    NbLocksLinearization: ULONG;
    NbComplexLocks: ULONG;
  end;

  D3DKMT_QUERYSTATSTICS_ALLOCATIONS = record
    Created: D3DKMT_QUERYSTATISTICS_COUNTER;
    Destroyed: D3DKMT_QUERYSTATISTICS_COUNTER;
    Opened: D3DKMT_QUERYSTATISTICS_COUNTER;
    Closed: D3DKMT_QUERYSTATISTICS_COUNTER;
    MigratedSuccess: D3DKMT_QUERYSTATISTICS_COUNTER;
    MigratedFail: D3DKMT_QUERYSTATISTICS_COUNTER;
    MigratedAbandoned: D3DKMT_QUERYSTATISTICS_COUNTER;
  end;

  D3DKMT_QUERYSTATSTICS_TERMINATIONS = record
    TerminatedShared: D3DKMT_QUERYSTATISTICS_COUNTER;
    TerminatedNonShared: D3DKMT_QUERYSTATISTICS_COUNTER;
    DestroyedShared: D3DKMT_QUERYSTATISTICS_COUNTER;
    DestroyedNonShared: D3DKMT_QUERYSTATISTICS_COUNTER;
  end;

  D3DKMT_QUERYSTATISTICS_ADAPTER_INFORMATION = record
    NbSegments: ULONG;
    NodeCount: ULONG;
    VidPnSourceCount: ULONG;
    VSyncEnabled: ULONG;
    TdrDetectedCount: ULONG;
    ZeroLengthDmaBuffers: LONGLONG;
    RestartedPeriod: ULONGLONG;
    ReferenceDmaBuffer: D3DKMT_QUERYSTATSTICS_REFERENCE_DMA_BUFFER;
    Renaming: D3DKMT_QUERYSTATSTICS_RENAMING;
    Preparation: D3DKMT_QUERYSTATSTICS_PREPRATION;
    PagingFault: D3DKMT_QUERYSTATSTICS_PAGING_FAULT;
    PagingTransfer: D3DKMT_QUERYSTATSTICS_PAGING_TRANSFER;
    SwizzlingRange: D3DKMT_QUERYSTATSTICS_SWIZZLING_RANGE;
    Locks: D3DKMT_QUERYSTATSTICS_LOCKS;
    Allocations: D3DKMT_QUERYSTATSTICS_ALLOCATIONS;
    Terminations: D3DKMT_QUERYSTATSTICS_TERMINATIONS;
    Reserved: array [0..7] of ULONG64;
  end;

  D3DKMT_QUERYRESULT_PREEMPTION_ATTEMPT_RESULT = (
    D3DKMT_PreemptionAttempt = 0,
    D3DKMT_PreemptionAttemptSuccess = 1,
    D3DKMT_PreemptionAttemptMissNoCommand = 2,
    D3DKMT_PreemptionAttemptMissNotEnabled = 3,
    D3DKMT_PreemptionAttemptMissNextFence = 4,
    D3DKMT_PreemptionAttemptMissPagingCommand = 5,
    D3DKMT_PreemptionAttemptMissSplittedCommand = 6,
    D3DKMT_PreemptionAttemptMissFenceCommand= 7,
    D3DKMT_PreemptionAttemptMissRenderPendingFlip = 8,
    D3DKMT_PreemptionAttemptMissNotMakingProgress = 9,
    D3DKMT_PreemptionAttemptMissLessPriority = 10,
    D3DKMT_PreemptionAttemptMissRemainingQuantum = 11,
    D3DKMT_PreemptionAttemptMissRemainingPreemptionQuantum = 12,
    D3DKMT_PreemptionAttemptMissAlreadyPreempting = 13,
    D3DKMT_PreemptionAttemptMissGlobalBlock = 14,
    D3DKMT_PreemptionAttemptMissAlreadyRunning = 15,
    D3DKMT_PreemptionAttemptStatisticsMax
  );

  D3DKMT_QUERYSTATISTICS_DMA_PACKET_TYPE = (
    D3DKMT_ClientRenderBuffer = 0,
    D3DKMT_ClientPagingBuffer = 1,
    D3DKMT_SystemPagingBuffer = 2,
    D3DKMT_SystemPreemptionBuffer = 3,
    D3DKMT_DmaPacketTypeMax
  );

  D3DKMT_QUERYSTATISTICS_QUEUE_PACKET_TYPE = (
    D3DKMT_RenderCommandBuffer = 0,
    D3DKMT_DeferredCommandBuffer = 1,
    D3DKMT_SystemCommandBuffer = 2,
    D3DKMT_MmIoFlipCommandBuffer = 3,
    D3DKMT_WaitCommandBuffer = 4,
    D3DKMT_SignalCommandBuffer = 5,
    D3DKMT_DeviceCommandBuffer = 6,
    D3DKMT_SoftwareCommandBuffer = 7,
    D3DKMT_QueuePacketTypeMax
  );

  D3DKMT_QUERYSTATISTICS_DMA_PACKET_TYPE_INFORMATION = record
    PacketSubmited: ULONG;
    PacketCompleted: ULONG;
    PacketPreempted: ULONG;
    PacketFaulted: ULONG;
  end;

  D3DKMT_QUERYSTATISTICS_QUEUE_PACKET_TYPE_INFORMATION = record
    PacketSubmited: ULONG;
    PacketCompleted: ULONG;
  end;

  D3DKMT_QUERYSTATISTICS_PACKET_INFORMATION = record
    QueuePacket: array [0..Integer(D3DKMT_QueuePacketTypeMax)-1] of
        D3DKMT_QUERYSTATISTICS_QUEUE_PACKET_TYPE_INFORMATION;
    DmaPacket: array [0..Integer(D3DKMT_DmaPacketTypeMax)-1] of
        D3DKMT_QUERYSTATISTICS_DMA_PACKET_TYPE_INFORMATION;
  end;

  D3DKMT_QUERYSTATISTICS_PREEMPTION_INFORMATION = record
    PreemptionCounter: array [0..Integer(D3DKMT_PreemptionAttemptStatisticsMax)-1] of ULONG;
  end;

  D3DKMT_QUERYSTATISTICS_PROCESS_NODE_INFORMATION = record
    RunningTime: LARGE_INTEGER;
    ContextSwitch: ULONG;
    PreemptionStatistics: D3DKMT_QUERYSTATISTICS_PREEMPTION_INFORMATION;
    PacketStatistics: D3DKMT_QUERYSTATISTICS_PACKET_INFORMATION;
    Reserverd: array [0..7] of ULONG64;
  end;

  D3DKMT_QUERYSTATISTICS_NODE_INFORMATION = record
    GlobalInformation: D3DKMT_QUERYSTATISTICS_PROCESS_NODE_INFORMATION;
    SystemInformation: D3DKMT_QUERYSTATISTICS_PROCESS_NODE_INFORMATION;
    Reserverd: array [0..7] of ULONG64;
  end;

  D3DKMT_QUERYSTATISTICS_RESULT = record
    case Integer of
      0: (AdapterInformation: D3DKMT_QUERYSTATISTICS_ADAPTER_INFORMATION);
      1: (NodeInformation: D3DKMT_QUERYSTATISTICS_NODE_INFORMATION);
  end;

  D3DKMT_QUERYSTATISTICS_QUERY_NODE = record
    NodeId: ULONG;
  end;

  D3DKMT_QUERYSTATISTICS_TYPE = (
    D3DKMT_QUERYSTATISTICS_NODE = 5
  );

  D3DKMT_QUERYSTATISTICS = record
    Type_: D3DKMT_QUERYSTATISTICS_TYPE;
    AdapterLuid: LUID;
    ProcessHandle: THandle;
    QueryResult: D3DKMT_QUERYSTATISTICS_RESULT;
    QueryNode: D3DKMT_QUERYSTATISTICS_QUERY_NODE;
  end;

var
  D3DKMTCloseAdapter: function (const Arg1: D3DKMT_CLOSEADAPTER): NTSTATUS; stdcall;
  D3DKMTOpenAdapterFromDeviceName: function (
      var Arg1: D3DKMT_OPENADAPTERFROMDEVICENAME): NTSTATUS; stdcall;
  D3DKMTQueryAdapterInfo: function (var Arg1: D3DKMT_QUERYADAPTERINFO): NTSTATUS; stdcall;
  D3DKMTQueryStatistics: function (var Arg1: D3DKMT_QUERYSTATISTICS): NTSTATUS; stdcall;

implementation

var
  h: THandle;
begin
  h := GetModuleHandle('gdi32.dll');
  // Vista and later
  D3DKMTCloseAdapter := GetProcAddress(h, 'D3DKMTCloseAdapter');
  D3DKMTOpenAdapterFromDeviceName := GetProcAddress(h, 'D3DKMTOpenAdapterFromDeviceName');
  D3DKMTQueryAdapterInfo := GetProcAddress(h, 'D3DKMTQueryAdapterInfo');
  D3DKMTQueryStatistics := GetProcAddress(h, 'D3DKMTQueryStatistics');
end.
